
var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function setValue(dsuid) {
    try {
        var oDevice=getDevices().byDSUID(dsuid);
        if (oDevice==null) {
            lWarn.logln('kein Device gefunden');
        }
        var oValue=parseInt(raisedEvent.parameter.value,10);
        lInfo.logln('Setze ' + dsuid + " auf " + oValue);
        oDevice.setValue(oValue);
    } catch(e) {
        lWarn.logln('Fehler beim SetManualValue '+ e);
    }
}

var iMaxStep=16;
var iMax=iMaxStep*2;

function makeDemo() {
	lInfo.logln('makeDemo');
    var deviceDSID=Property.getProperty('demo/dsuid');
    var iMaxCounter=Property.getProperty('demo/counter');
    var iStep=Property.getProperty('demo/step');
    
    var fState=Property.getProperty('demo/state');
    if (deviceDSID==null) {
    	stopDemo();
        lInfo.logln('no DemoDSID');
        return;
    } 
        
    if (deviceDSID=='') {
    	stopDemo();
        lInfo.logln('no DemoDSID');
        return;
    }
        
    if (fState==null) {
    	stopDemo();
        lInfo.logln('stop Demo');
        return;
    } 
        
    if (fState==false) {
    	stopDemo();
        lInfo.logln('stop Demo');
        return;
    }
    
    if (iMaxCounter>=iMax) {
    	stopDemo();
        lInfo.logln('Ende Aktion');
        try {
            var oDevice=getDevices().byDSUID(deviceDSID);
            if (oDevice!=null) {
                oDevice.setValue(0);
            }
        } catch (e) {
        }
        return;
    }
    iStep=(iStep + Math.floor(256/iMaxStep))%256;
    Property.setProperty('demo/step',iStep);
    lInfo.logln('Make Step : '+ iStep + ' for ' + deviceDSID + ' Step ' + iMaxCounter + ' of ' + iMax + '\n');    
    try {
        var oDevice=getDevices().byDSUID(deviceDSID);
        if (oDevice==null) {
        	stopDemo();
            sErrorMSG='Gert ' + deviceDSID + ' nicht gefunden';
            lWarn.logln(sErrorMSG);
            return;
        }
        oDevice.setValue(parseInt(iStep,10));
    } catch (e) {
    	stopDemo();
        lInfo.logln('83 Ende Aktion aufgrund Fehler ' + e);
        return;
    }
    Property.setProperty('demo/counter',iMaxCounter+1);
    new Event('led-wizard.demo',{step:iStep}).raise();
    new Event('led-wizard.answer',{type:'demo',step:iStep}).raise();
    setTimeout(makeDemo,750);
}


function startDemo(dsuid){
	lInfo.logln('Start Demo');   
	Property.setProperty('demo/state', true);
	
    if (raisedEvent.parameter.dsuid==null)
        return;
    var fOngoing=true;
    if (Property.getProperty('demo/dsuid')==null)
        fOngoing=false;
    if (Property.getProperty('demo/dsuid')=='')
        fOngoing=false;
    
    Property.setProperty('demo/dsuid',dsuid);
    Property.setProperty('demo/counter',0);
    Property.setProperty('demo/step',-1);
    if (!fOngoing) {
        lInfo.logln('starte zyklus');
	    new Event('led-wizard.demo',{state:true}).raise();
	    new Event('led-wizard.answer',{type:'demo',state:true}).raise();
        makeDemo();
    } else {
        lInfo.logln('Demo luft schon');
    }
	
	
}

function stopDemo(){
	 lInfo.logln('Stop Demo');   
	 
	    try {
	    	 lInfo.logln('Stop Demo 1');    
	        var deviceDSID=Property.getProperty('demo/dsuid');
	    	 lInfo.logln('Stop Demo 2');  
	        var oDevice=getDevices().byDSUID(deviceDSID);
	    	 lInfo.logln('Stop Demo 3');    
	        if (oDevice!=null) {
	        	 lInfo.logln('Stop Demo 4');    
	             oDevice.setValue(0,'manual');
		    	 lInfo.logln('Stop Demo 5');    

	            new Event('led-wizard.demo',{step:0}).raise();
		    	 lInfo.logln('Stop Demo 6');    

	            new Event('led-wizard.answer',{type:'demo',step:0}).raise();
		    	 lInfo.logln('Stop Demo 7');    

	        }
	    	 lInfo.logln('Stop Demo 9');    
	    } catch (e) {
	    	lInfo.logln('132 Ende Aktion aufgrund Fehler ' + e);
	    }
	    
	    lInfo.logln('Stop Demo');    
	    new Event('led-wizard.demo',{state:false}).raise();
	    new Event('led-wizard.answer',{type:'demo',state:false}).raise();
		Property.setProperty('demo/state', false);
	    Property.setProperty('demo/dsuid','');
}

if (raisedEvent.parameter.actions != null) {
	Property.load();
	if (raisedEvent.parameter.actions == 'setValue') {		
		if (raisedEvent.parameter.dsuid!=null)
			setValue(raisedEvent.parameter.dsuid);
    	
    }	
	if (raisedEvent.parameter.actions == 'startDemoModus') {	
		if (raisedEvent.parameter.dsuid!=null)
			startDemo(raisedEvent.parameter.dsuid);
    }	
	if (raisedEvent.parameter.actions == 'stopDemoModus') {
		stopDemo();
    }	
	if (raisedEvent.parameter.actions == 'toggleDemoModus') {
		if (raisedEvent.parameter.dsuid!=null) {
			var fStart=true;
			if (Property.getNode('demo/state')!=null)
				if (Property.getNode('demo/state').getValue()==true)
					fStart=false;
			if (fStart)
				startDemo(raisedEvent.parameter.dsuid);
			else
				stopDemo(raisedEvent.parameter.dsuid);
		}
    }			
}
